﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using FirebirdSql.Data.FirebirdClient;

namespace SFFirebirdWPF
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            FbConnectionStringBuilder connectString = ConnectionStringBuilder();

            ALinq.DataContext db;
            db = new ALinq.DataContext(connectString.ConnectionString, typeof(ALinq.Firebird.FirebirdProvider));
            var tt = db.GetTable<ADataModels.SPELEMENTS>();

            Syncfusion.UI.Xaml.Grid.GridVirtualizingCollectionView gv = new Syncfusion.UI.Xaml.Grid.GridVirtualizingCollectionView(tt);
            SfDataGrid1.ItemsSource = gv;
        }

        private  FbConnectionStringBuilder ConnectionStringBuilder()
        {
            var asm = System.Reflection.Assembly.GetExecutingAssembly();

            string dirName = null;
            //if(Environment.Is64BitProcess) dirName=System.IO.Path.GetDirectoryName(asm.Location)+"\\firebird X64";
            //else 
            dirName = System.IO.Path.GetDirectoryName(asm.Location) + "\\firebird X86";
            FbConnectionStringBuilder connectString = new FbConnectionStringBuilder();
            connectString.Database = "test.FDB";
            connectString.Dialect = 3;
            connectString.DataSource = "localhost";
            connectString.UserID = "SYSDBA";
            connectString.Password = "masterkey";
            connectString.ServerType = FbServerType.Embedded;
            // connectString.ServerType = FbServerType.Default;
            connectString.Pooling = true;
            connectString.MinPoolSize = 0;
            connectString.MaxPoolSize = 50;
            connectString.Pooling = true;
            connectString.ClientLibrary = dirName + "\\fbclient.dll";
            connectString.Charset = "UTF8";

            return connectString;
        }
    }
}
